<!doctype html>
<html lang="en">
<head>

<meta charset="UTF-8">
<title>Hello, WebAuthn!</title>

</head>
<body>

<h1>Hello, WebAuthn!</h1>

<form action="#">

<p>email: <input type="text" id="email" placeholder="email@example.com"></p>

<br>
<button id="login">Login</button><br>

</form>

<br>

<p id="message"></p>

<br>

<a href="index.html">TOP</a><br>

<script>
document.addEventListener("DOMContentLoaded", function(){
  document.getElementById("login").addEventListener("click", login);
});

async function login(){
  try {
    if (!window.PublicKeyCredential) {
      throw "Oops! this browser does not support WebAuthn...";
    }

    const user = getUser();
    const {publicKey} = await begin({user});
    const assertion = await navigator.credentials.get({publicKey});
    const result = await finish({assertion});

    document.getElementById("message").innerHTML = result;
  } catch (e) {
    document.getElementById("message").innerHTML = e;
  }
}

function getUser() {
  const email = document.getElementById("email").value;

  if (email.length == 0) {
    throw "name is empty";
  }

  return {email};
}

async function begin({user}) {
  const response = await fetch("/login/begin", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({
      "email": user.email,
    }),
  });

  const json = await response.json();

  if (!response.ok) {
    throw "error: failed beginning authentication: " + JSON.stringify(json);
  }

  const publicKey = json.publicKey;
  decodePublicKey(publicKey);

  return {
    publicKey,
  };
}
function decodePublicKey(publicKey) {
  publicKey.challenge = bufferDecode(publicKey.challenge);
  publicKey.allowCredentials.forEach((item) => item.id = bufferDecode(item.id));
}
function bufferDecode(value) {
  return Uint8Array.from(atob(value), c => c.charCodeAt(0));
}

async function finish({assertion}) {
  const response = await fetch("/login/finish", {
    method: "POST",
    headers: { "Content-Type": "application/json" },
    body: JSON.stringify({
      id: assertion.id,
      type: assertion.type,
      rawId: bufferEncode(assertion.rawId),
      response: {
        authenticatorData: bufferEncode(assertion.response.authenticatorData),
        clientDataJSON: bufferEncode(assertion.response.clientDataJSON),
        signature: bufferEncode(assertion.response.signature),
        userHandle: bufferEncode(assertion.response.userHandle),
      },
    }),
  });

  const json = await response.json();

  if (!response.ok) {
    throw "error: failed finishing registration: " + JSON.stringify(json);
  }

  return json;
}
function bufferEncode(value) {
  return btoa(String.fromCharCode.apply(null, new Uint8Array(value)))
    .replace(/\+/g, "-")
    .replace(/\//g, "_")
    .replace(/=/g, "");
}
</script>
</body>
</html>
